osg::GraphicsObjectManager Class Referenceabstract

`#include <GLObjects>`

Inheritance diagram for osg::GraphicsObjectManager:

## Public Member Functions

| GraphicsObjectManager (const std::string &name, unsigned int contextID)
unsigned int | getContextID () const
virtual void | newFrame (osg::FrameStamp *)
virtual void | resetStats ()
virtual void | reportStats (std::ostream &)
virtual void | recomputeStats (std::ostream &) const
virtual void | flushDeletedGLObjects (double currentTime, double &availableTime)=0
virtual void | flushAllDeletedGLObjects ()=0
virtual void | deleteAllGLObjects ()=0
virtual void | discardAllGLObjects ()=0
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~GraphicsObjectManager ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

std::string | _name
unsigned int | _contextID
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## GraphicsObjectManager()

osg::GraphicsObjectManager::GraphicsObjectManager | ( | const std::string & | name,
|  | unsigned int | contextID )

## ~GraphicsObjectManager()

virtual osg::GraphicsObjectManager::~GraphicsObjectManager | ( |  | ) |

protected virtual

## Member Function Documentation

## deleteAllGLObjects()

virtual void osg::GraphicsObjectManager::deleteAllGLObjects | ( |  | ) |

pure virtual

Do a GL delete all OpenGL objects. Note, must be called from a thread which has current the graphics context associated with contextID.

Implemented in osg::ContextData, osg::GLBufferObjectManager, osg::GLObjectManager, and osg::TextureObjectManager.

## discardAllGLObjects()

virtual void osg::GraphicsObjectManager::discardAllGLObjects | ( |  | ) |

pure virtual

Discard all OpenGL objects. Note, unlike deleteAllGLjects discard does not do any OpenGL calls so can be called from any thread, but as a consequence it also doesn't remove the associated OpenGL resource so discard should only be called when the associated graphics context is being/has been closed.

Implemented in osg::ContextData, osg::GLBufferObjectManager, osg::GLObjectManager, and osg::TextureObjectManager.

## flushAllDeletedGLObjects()

virtual void osg::GraphicsObjectManager::flushAllDeletedGLObjects | ( |  | ) |

pure virtual

Flush all deleted OpenGL objects. Note, must be called from a thread which has current the graphics context associated with contextID.

Implemented in osg::ContextData, osg::GLBufferObjectManager, osg::GLObjectManager, and osg::TextureObjectManager.

## flushDeletedGLObjects()

virtual void osg::GraphicsObjectManager::flushDeletedGLObjects | ( | double | currentTime,
|  | double & | availableTime )

pure virtual

Flush all deleted OpenGL objects within the specified availableTime. Note, must be called from a thread which has current the graphics context associated with contextID.

Implemented in osg::ContextData, osg::GLBufferObjectManager, osg::GLObjectManager, and osg::TextureObjectManager.

## getContextID()

unsigned int osg::GraphicsObjectManager::getContextID | ( |  | ) | const

inline

References _contextID.

## newFrame()

virtual void osg::GraphicsObjectManager::newFrame | ( | osg::FrameStamp * |  | ) |

inline virtual

Signal that a new frame has started.

Reimplemented in osg::ContextData, osg::GLBufferObjectManager, and osg::TextureObjectManager.

## recomputeStats()

virtual void osg::GraphicsObjectManager::recomputeStats | ( | std::ostream & |  | ) | const

inline virtual

Reimplemented in osg::ContextData, osg::GLBufferObjectManager, and osg::TextureObjectManager.

## reportStats()

virtual void osg::GraphicsObjectManager::reportStats | ( | std::ostream & |  | ) |

inline virtual

Reimplemented in osg::ContextData, osg::GLBufferObjectManager, and osg::TextureObjectManager.

## resetStats()

virtual void osg::GraphicsObjectManager::resetStats | ( |  | ) |

inline virtual

Reimplemented in osg::ContextData, osg::GLBufferObjectManager, and osg::TextureObjectManager.

## Member Data Documentation

## _contextID

unsigned int osg::GraphicsObjectManager::_contextID

protected

Referenced by osg::ContextData::get(), and getContextID().

## _name

std::string osg::GraphicsObjectManager::_name

protected

The documentation for this class was generated from the following file:

- GLObjects